#ifndef MAINWINDOWIMPL_H
#define MAINWINDOWIMPL_H
//
#include "ui_mainwindow.h"
#include "config.h"

class QFile;
class QFtp;
class QHttp;
class QProgressBar;
class Smtp;
class Log;

//
class MainWindowImpl : public QMainWindow, public Ui::MainWindow
{
Q_OBJECT
public:
	MainWindowImpl( QWidget * parent = 0, Qt::WFlags f = 0 );
public slots:
	void writeSettings();
	void readSettings();
	void openFile(QString fileName);
	
private slots:
	void mailDisconnected();
	void sendMails();
	void sendNextMail();
	void mailSendError();
	void getFileFTP(QString filename, QString dir = "");
	void readCategories();
	void loadConfigDlg();
	void loadReplaceDlg();
	void createStatusbar();
	void createDockWidgets();
	void convertCatFile();
	void ftpCommandFinished(int,bool);
	void refreshCategories();
	void updateDataTransferProgress(qint64, qint64);
	void updateText(int activeText);
	void updateToList();
	void newFile();
	void openFile();
	void on_txtCleartext_textChanged();
	void saveFile();
	void saveFile(QString fileName);
	void saveFileAs();
	void replaceText();
	void loadHeader();
	
private:
	enum {MagicNumber = 0x98c57f26 };
	QString catFileName;

	Log *log;

	bool htmlMode;
	bool getCatOnStart;
	bool clearTextChanged;
	
	QLabel *state;
	QLabel *date;
	QProgressBar *progressBar;
	
	QTextEdit *logText;

	QString smtpHost;
	QString smtpUsr;
	QString smtpPwd;

	QString ftpHost;
	QString ftpUsr;
	QString ftpPwd;
	QString ftpCategoryFile;
	QString ftpPath;
	QStringList ftpFiles;
	bool getCatFtp;
	bool downloadLists;
	bool downloadRcptList;

	QString pathGroup;
	QString pathArchive;
	QString pathPlugins;
	QString pathHeader;
	
	QString fName;
	QString categoryFile;
	
	QList<RecipientList> Groups;
	QList< QPair<QString,QString> > replaceList;
	
	QFile *file;
	QFtp *ftp;
	QHttp *http;
	Smtp *newMail;
	QStringList *rcptList;
	int sendingMode;
	int maxRcpt;
	
	void closeEvent(QCloseEvent *event);
};
#endif




